import inspect
import databutton.helpers.parse as parse
import os

# Global var to store all streamlit apps
_streamlit_apps = {}

# Decorator for defining a method as a streamlit app


def streamlit(route):
    def app(func):
        codelines = inspect.getsourcelines(func)
        filename = './.databutton/app/tmp-' + route.split('/')[-1] + '.py'
        if(os.path.exists('./.databutton/app') is False):
            os.makedirs('./.databutton/app')

        imports = parse.get_library_dependencies_for_app(inspect.getsourcefile(func))
        with open(filename, 'w') as f:
            f.writelines(imports)
            f.write('\n')
            for line in codelines[0][2:]:
                f.write(line[4:])

        _streamlit_apps[route] = filename
    return app
